Skip to content
New issue

Have a question about this project? Sign up for a free GitHub account to open an issue and contact its maintainers and the community.

By clicking “Sign up for GitHub”, you agree to our terms of service and privacy statement. We’ll occasionally send you account related emails.

Already on GitHub? Sign in to your account

julia: init at 1.5 #101933

Merged
merged 7 commits into from Nov 13, 2020
Merged

julia: init at 1.5 #101933

merged 7 commits into from Nov 13, 2020

Conversation

@cstich
Copy link
Contributor

@cstich cstich commented Oct 28, 2020

This updates julia to version 1.5. I have left 1.3 in for now as I am guessing people are still using that one and we are skipping 1.4 with this one.

Motivation for this change
Things done
  • Tested using sandboxing (nix.useSandbox on NixOS, or option sandbox in nix.conf on non-NixOS linux)
  • Built on platform(s)
    • NixOS
    • macOS
    • other Linux distributions
  • Tested via one or more NixOS test(s) if existing and applicable for the change (look inside nixos/tests)
  • Tested compilation of all pkgs that depend on this change using nix-shell -p nixpkgs-review --run "nixpkgs-review wip"
  • Tested execution of all binary files (usually in ./result/bin/)
  • Determined the impact on package closure size (by running nix path-info -S before and after)
  • Ensured that relevant documentation is up to date
  • Fits CONTRIBUTING.md.
pkgs/development/compilers/julia/1.5.nix Outdated Show resolved Hide resolved
pkgs/development/compilers/julia/1.5.nix Outdated Show resolved Hide resolved
pkgs/development/compilers/julia/1.5.nix Outdated Show resolved Hide resolved
# Julia applies a lot of patches to its dependencies, so for now do not use the system LLVM
# https://github.com/JuliaLang/julia/tree/master/deps/patches
Comment on lines 83 to 84

This comment has been minimized.

@SuperSandro2000

SuperSandro2000 Oct 28, 2020
Member

Suggested change
# Julia applies a lot of patches to its dependencies, so for now do not use the system LLVM
# https://github.com/JuliaLang/julia/tree/master/deps/patches
# Julia applies a lot of patches to its dependencies, so for now do not use the system LLVM
# https://github.com/JuliaLang/julia/tree/master/deps/patches
pkgs/development/compilers/julia/1.5.nix Outdated Show resolved Hide resolved



Comment on lines +9367 to +9369

This comment has been minimized.

@SuperSandro2000

SuperSandro2000 Oct 28, 2020
Member

Suggested change
@SuperSandro2000
Copy link
Member

@SuperSandro2000 SuperSandro2000 commented Oct 28, 2020

Result of nixpkgs-review pr 101933 1 run on x86_64-darwin

1 package failed to build:
  • julia_15
CMake Warning:
  Manually-specified variables were not used by the project:

    CMAKE_INSTALL_BINDIR
    CMAKE_INSTALL_LIBDIR
    LIB_INSTALL_DIR


-- Build files have been written to: /tmp/nix-build-julia-1.5.2.drv-0/source/deps/scratch/llvm-9.0.1/build_Release
make: *** [Makefile:60: julia-deps] Error 2
@r-burns
Copy link
Contributor

@r-burns r-burns commented Oct 29, 2020

Might want to take a look at #98043 first, there's already ongoing work on julia

@cstich
Copy link
Contributor Author

@cstich cstich commented Oct 29, 2020

What's the preferred way to go forward now that there is also the work going on in #98043? Shall I fix the issues with my commit so that we get a working version of julia 1.5 or wait for #98043?

Edit: I am happy for my expression to be superseded once we have a more sane expression.

@doronbehar
Copy link
Contributor

@doronbehar doronbehar commented Oct 29, 2020

I'm confused - you opened this PR as a non draft, and it seems the build fails here. OTH you said that my PR makes julia compile, whereas someone else said that my PR fails to build. 😕

@cstich
Copy link
Contributor Author

@cstich cstich commented Oct 29, 2020

I'm confused - you opened this PR as a non draft, and it seems the build fails here. OTH you said that my PR makes julia compile, whereas someone else said that my PR fails to build. confused

Okay. Let me try to recap.

I opened this pull request before I knew about #98043. My pull request also works for me locally and I get a working binary from my pull request. I have to admit that I do not really know how to get all the other tests done locally before issuing a pull request.

After I posted my pull request, someone else pointed out that #98043 exists and then I was not sure what to do about my pull request. I then tried to compile #98043 and that compiles for me locally.

Does that make sense now?

Edit: And also I did not know you could open pull request as a draft either. I am not doing it frequently enough to have come across that since they introduced it in 2019.

@doronbehar
Copy link
Contributor

@doronbehar doronbehar commented Oct 29, 2020

I have to admit that I do not really know how to get all the other tests done locally before issuing a pull request.

What tests?

My pull request also works for me locally and I get a working binary from my pull request.

So how do we explain @SuperSandro2000's results saying it won't build for them?

I then tried to compile #98043 and that compiles for me locally.

So You say it compiles for you but then again someone else says my PR won't compile for them: #98043 (comment)

How do you test your builds? Do you do a checkout of the PR? Do you use nixpkgs-review (It's the best way to do it)?

@cstich
Copy link
Contributor Author

@cstich cstich commented Oct 29, 2020

I have to admit that I do not really know how to get all the other tests done locally before issuing a pull request.

What tests?

The CI tests that are run when issuing a pull request.

My pull request also works for me locally and I get a working binary from my pull request.

So how do we explain @SuperSandro2000's results saying it won't build for them?

My best guess then is that there is a difference between nixpkgs-review pr 101933 and nix build -A julia_15.
What makes it even more confusing though is, if I do nixpkgs-review rev 50866d2dcbd258b0e17186537e07a13727b56b65 on my machine, it drops me in a nix shell with a working version of julia 1.5.2.

I then tried to compile #98043 and that compiles for me locally.

So You say it compiles for you but then again someone else says my PR won't compile for them: #98043 (comment)

Effectively yes. I pulled in your pull request into my local repository, swapped to the branch with your pull request and did `nix build -A jullia' and that produces a binary that I can use. Am I doing something wrong here?

How do you test your builds? Do you do a checkout of the PR? Do you use nixpkgs-review (It's the best way to do it)?

I check out my PR and then do nix build and see what the output of that is. I also usually run the binaries that are found in result. I have never heard of nixpkgs-review before. It's not mentioned in the manual when talking about adding packages to nixpkgs, so I missed it. Thanks for the pointer.

Edit: Could it be because I have nix.useSandbox = false; set? I remember having had issues with building julia without that before.

@doronbehar
Copy link
Contributor

@doronbehar doronbehar commented Oct 29, 2020

With nix show-derivation -f. julia_15 I couldn't find a difference between the derivation here, merged to current master, and the derivation on your julia_15 branch (Using hub pr checkout). To be precise, I run:

git checkout julia_15
nix show-derivation -f. julia_15 > julia-original.json
git checkout master
git pull
curl -Ls https://github.com/NixOS/nixpkgs/pull/101933.patch | git apply
nix show-derivation -f. julia_15 > julia-merged-to-master.json
diff julia*.json

For my PR I haven't tested these differences.

@matklad
Copy link
Member

@matklad matklad commented Oct 29, 2020

Hey, I've checked this PR locally (rebased on top of current unsable), and it works!

Thanks @cstich -- all my local plumbing scripts are in julia, rather than bash/python, so this work is a lifesaver!

Copy link
Contributor

@doronbehar doronbehar left a comment

This looks great overall :). Though I still don't understand why @SuperSandro2000 had a failure with nixpkgs-review and @matklad hadn't.

prePatch = ''
export PATH=$PATH:${cmake}/bin
'';
Comment on lines 37 to 39

This comment has been minimized.

@doronbehar

doronbehar Oct 29, 2020
Contributor

I'd add cmake to native inputs and use dontUseCmakeConfigure = true;.

This comment has been minimized.

@doronbehar

doronbehar Nov 8, 2020
Contributor

@cstich besides this little nitpick everything looks good to me. Only could you please squash the commits?

pkgs/development/compilers/julia/1.5.nix Outdated Show resolved Hide resolved
pkgs/development/compilers/julia/1.5.nix Outdated Show resolved Hide resolved
pkgs/development/compilers/julia/1.5.nix Outdated Show resolved Hide resolved
pkgs/development/compilers/julia/1.5.nix Outdated Show resolved Hide resolved
@doronbehar
Copy link
Contributor

@doronbehar doronbehar commented Oct 30, 2020

@energizah
Copy link

@energizah energizah commented Nov 4, 2020

Feel free to mark off-topic if this is irrelevant:

I've been trying to build GLMakie.jl, but couldn't. If the new nixpkgs.julia_15 package needs some extra dependency in order to support GLMakie it would be nice to have it in.

@7c6f434c
Copy link
Member

@7c6f434c 7c6f434c commented Nov 7, 2020

Data point: also builds for me. Should we start colelcting CPU models?

@doronbehar
Copy link
Contributor

@doronbehar doronbehar commented Nov 7, 2020

I've been trying to build GLMakie.jl, but couldn't.

@energizah did you try using GLMakie.jl with the julia build of this PR?

@energizah
Copy link

@energizah energizah commented Nov 7, 2020

@doronbehar

@energizah did you try using GLMakie.jl with the julia build of this PR?

Yeah but it didn't work.


% sudo lspci | rg VGA
00:02.0 VGA compatible controller: Intel Corporation HD Graphics 530 (rev 06)
(jlplot) pkg> add GLMakie
  Resolving package versions...
  Installed isoband_jll ─────────────── v0.2.2+0
  Installed EarCut_jll ──────────────── v2.1.5+1
  Installed Libiconv_jll ────────────── v1.16.0+7
  Installed Xorg_libXinerama_jll ────── v1.1.4+4
  Installed Xorg_libXfixes_jll ──────── v5.0.3+4
  Installed Xorg_libxcb_jll ─────────── v1.13.0+3
  Installed GridLayoutBase ──────────── v0.4.1
  Installed GLMakie ─────────────────── v0.1.14
  Installed FriBidi_jll ─────────────── v1.0.5+6
  Installed OpenSSL_jll ─────────────── v1.1.1+6
  Installed Xorg_libX11_jll ─────────── v1.6.9+4
  Installed Xorg_libXext_jll ────────── v1.3.4+4
  Installed Xorg_xtrans_jll ─────────── v1.4.0+3
  Installed Ogg_jll ─────────────────── v1.3.4+2
  Installed libvorbis_jll ───────────── v1.3.6+6
  Installed FFMPEG ──────────────────── v0.4.0
  Installed ImageIO ─────────────────── v0.3.1
  Installed Packing ─────────────────── v0.4.1
  Installed Xorg_libpthread_stubs_jll ─ v0.1.0+3
  Installed libpng_jll ──────────────── v1.6.37+6
  Installed XSLT_jll ────────────────── v1.1.33+4
  Installed x264_jll ────────────────── v2020.7.14+2
  Installed ShaderAbstractions ──────── v0.2.3
  Installed FreeTypeAbstraction ─────── v0.8.1
  Installed libass_jll ──────────────── v0.14.0+4
  Installed LAME_jll ────────────────── v3.100.0+3
  Installed Libgpg_error_jll ────────── v1.36.0+3
  Installed Isoband ─────────────────── v0.1.1
  Installed GLFW_jll ────────────────── v3.3.2+1
  Installed Xorg_libXi_jll ──────────── v1.7.10+4
  Installed GLFW ────────────────────── v3.4.0
  Installed FreeType ────────────────── v3.0.1
  Installed Xorg_libXrandr_jll ──────── v1.5.2+4
  Installed FreeType2_jll ───────────── v2.10.1+5
  Installed XML2_jll ────────────────── v2.9.10+3
  Installed Xorg_libXcursor_jll ─────── v1.2.0+4
  Installed Xorg_libXdmcp_jll ───────── v1.1.3+4
  Installed PNGFiles ────────────────── v0.3.2
  Installed Bzip2_jll ───────────────── v1.0.6+5
  Installed Libgcrypt_jll ───────────── v1.8.5+4
  Installed FFMPEG_jll ──────────────── v4.3.1+4
  Installed Zlib_jll ────────────────── v1.2.11+18
  Installed MeshIO ──────────────────── v0.4.3
  Installed x265_jll ────────────────── v3.0.0+3
  Installed LibVPX_jll ──────────────── v1.9.0+1
  Installed Animations ──────────────── v0.4.1
  Installed Opus_jll ────────────────── v1.3.1+3
  Installed Xorg_libXrender_jll ─────── v0.9.10+4
  Installed PolygonOps ──────────────── v0.1.1
  Installed libfdk_aac_jll ──────────── v0.1.6+4
  Installed Xorg_libXau_jll ─────────── v1.0.9+4
  Installed IntervalSets ────────────── v0.5.1
  Installed GeometryBasics ──────────── v0.3.3
  Installed Libglvnd_jll ────────────── v1.3.0+3
  Installed AbstractPlotting ────────── v0.13.5
Downloading artifact: Libiconv
Downloading artifact: Xorg_libXinerama
Downloading artifact: isoband
Downloading artifact: Xorg_libXfixes
Downloading artifact: EarCut
Downloading artifact: Xorg_libxcb
Downloading artifact: Xorg_libXext
Downloading artifact: FriBidi
Downloading artifact: Xorg_libX11
Downloading artifact: Xorg_xtrans
Downloading artifact: Ogg
Downloading artifact: libvorbis
Downloading artifact: OpenSSL
Downloading artifact: libpng
Downloading artifact: Xorg_libpthread_stubs
Downloading artifact: XSLT
Downloading artifact: x264
Downloading artifact: libass
Downloading artifact: LAME
Downloading artifact: Libgpg_error
Downloading artifact: Xorg_libXi
Downloading artifact: GLFW
Downloading artifact: Xorg_libXrandr
Downloading artifact: FreeType2
Downloading artifact: Xorg_libXcursor
Downloading artifact: XML2
Downloading artifact: Xorg_libXdmcp
Downloading artifact: Bzip2
Downloading artifact: Libgcrypt
Downloading artifact: Zlib
Downloading artifact: FFMPEG
Downloading artifact: x265
Downloading artifact: LibVPX
Downloading artifact: Opus
Downloading artifact: Xorg_libXrender
Downloading artifact: libfdk_aac
Downloading artifact: Xorg_libXau
Downloading artifact: Libglvnd
Updating `~/tmp/jlplot/Project.toml`
  [e9467ef8] + GLMakie v0.1.14
Updating `~/tmp/jlplot/Manifest.toml`
  [537997a7] + AbstractPlotting v0.13.5
  [27a7e980] + Animations v0.4.1
  [6e34b625] + Bzip2_jll v1.0.6+5
  [fa961155] + CEnum v0.4.1
  [a2cac450] + ColorBrewer v0.4.0
  [35d6a980] + ColorSchemes v3.10.1
  [c3611d14] + ColorVectorSpace v0.8.6
  [e2d170a0] + DataValueInterfaces v1.0.0
  [5ae413db] + EarCut_jll v2.1.5+1
  [da5c29d0] + EllipsisNotation v0.4.0
  [c87230d0] + FFMPEG v0.4.0
  [b22a6f82] + FFMPEG_jll v4.3.1+4
  [5789e2e9] + FileIO v1.4.4
  [59287772] + Formatting v0.4.1
  [b38be410] + FreeType v3.0.1
  [d7e528f0] + FreeType2_jll v2.10.1+5
  [663a7486] + FreeTypeAbstraction v0.8.1
  [559328eb] + FriBidi_jll v1.0.5+6
  [f7f18e0c] + GLFW v3.4.0
  [0656b61e] + GLFW_jll v3.3.2+1
  [e9467ef8] + GLMakie v0.1.14
  [5c1252a2] + GeometryBasics v0.3.3
  [a2bd30eb] + Graphics v1.0.2
  [3955a311] + GridLayoutBase v0.4.1
  [a09fc81d] + ImageCore v0.8.18
  [82e4d734] + ImageIO v0.3.1
  [8197267c] + IntervalSets v0.5.1
  [f1662d9f] + Isoband v0.1.1
  [82899510] + IteratorInterfaceExtensions v1.0.0
  [c1c5ebd0] + LAME_jll v3.100.0+3
  [dd192d2f] + LibVPX_jll v1.9.0+1
  [d4300ac3] + Libgcrypt_jll v1.8.5+4
  [7e76a0d4] + Libglvnd_jll v1.3.0+3
  [7add5ba3] + Libgpg_error_jll v1.36.0+3
  [94ce4f54] + Libiconv_jll v1.16.0+7
  [dbb5928d] + MappedArrays v0.3.0
  [7eb4fadd] + Match v1.1.0
  [7269a6da] + MeshIO v0.4.3
  [66fc600b] + ModernGL v1.1.2
  [e94cdb99] + MosaicViews v0.2.4
  [77ba4419] + NaNMath v0.3.4
  [510215fc] + Observables v0.3.2
  [e7412a2a] + Ogg_jll v1.3.4+2
  [458c3c95] + OpenSSL_jll v1.1.1+6
  [91d4177d] + Opus_jll v1.3.1+3
  [f57f5aa1] + PNGFiles v0.3.2
  [19eb6ba3] + Packing v0.4.1
  [5432bcbf] + PaddedViews v0.5.6
  [995b91a9] + PlotUtils v1.0.7
  [647866c9] + PolygonOps v0.1.1
  [65257c39] + ShaderAbstractions v0.2.3
  [73760f76] + SignedDistanceFields v0.4.0
  [09ab397b] + StructArrays v0.4.4
  [3783bdb8] + TableTraits v1.0.0
  [bd369af6] + Tables v1.1.0
  [1cfade01] + UnicodeFun v0.4.1
  [02c8fc9c] + XML2_jll v2.9.10+3
  [aed1982a] + XSLT_jll v1.1.33+4
  [4f6342f7] + Xorg_libX11_jll v1.6.9+4
  [0c0b7dd1] + Xorg_libXau_jll v1.0.9+4
  [935fb764] + Xorg_libXcursor_jll v1.2.0+4
  [a3789734] + Xorg_libXdmcp_jll v1.1.3+4
  [1082639a] + Xorg_libXext_jll v1.3.4+4
  [d091e8ba] + Xorg_libXfixes_jll v5.0.3+4
  [a51aa0fd] + Xorg_libXi_jll v1.7.10+4
  [d1454406] + Xorg_libXinerama_jll v1.1.4+4
  [ec84b674] + Xorg_libXrandr_jll v1.5.2+4
  [ea2f1a96] + Xorg_libXrender_jll v0.9.10+4
  [14d82f49] + Xorg_libpthread_stubs_jll v0.1.0+3
  [c7cfdc94] + Xorg_libxcb_jll v1.13.0+3
  [c5fb5394] + Xorg_xtrans_jll v1.4.0+3
  [83775a58] + Zlib_jll v1.2.11+18
  [9a68df92] + isoband_jll v0.2.2+0
  [0ac62f75] + libass_jll v0.14.0+4
  [f638f0a6] + libfdk_aac_jll v0.1.6+4
  [b53b4c65] + libpng_jll v1.6.37+6
  [f27f6e37] + libvorbis_jll v1.3.6+6
  [1270edf5] + x264_jll v2020.7.14+2
  [dfaa095f] + x265_jll v3.0.0+3
   Building GLMakie → `~/.julia/packages/GLMakie/9pp6B/deps/build.log`
┌ Error: Error building `GLMakie`: 
│ init error of GLFW
│ ERROR: LoadError: OpenGL/GLFW wasn't installed correctly. This likely means,
│ you don't have an OpenGL capable Graphic Card,
│ you don't have the newest video driver installed,
│ or the GLFW build failed. If you're on linux and `]build` GLFW failed,
│ try manually adding `sudo apt-get install libglfw3` and then `]build GLMakie`.
│ If you're on a headless server, you still need to install x-server and
│ proper GPU drivers. You can take inspiration from this article
│ on how to get Makie running on a headless system:
│ https://nextjournal.com/sdanisch/makie-1.0
│ If you don't have a GPU, there is also a Cairo software backend
│ for Makie which you can use:
│ https://github.com/JuliaPlots/CairoMakie.jl.
│ Please check the below error and open an issue at:
│ https://github.com/JuliaPlots/GLMakie.jl.
│ After you fixed your OpenGL install, please run `]build GLMakie` again!
│ GLMakie will still load, but will be disabled as a default backend for Makie
│ 
│ Stacktrace:
│  [1] error(::String) at /nix/store/lkviqn14m8cd35m1y9y7bc3iy148f515-julia-1.5.2/lib/julia/sys.so:?
│  [2] top-level scope at /home/user/.julia/packages/GLMakie/9pp6B/deps/build.jl:63
│  [3] include(::String) at ./client.jl:457
│  [4] top-level scope at none:5
│ in expression starting at /home/user/.julia/packages/GLMakie/9pp6B/deps/build.jl:31
│ caused by [exception 1]
│ GLFWError (API_UNAVAILABLE): GLX: No GLXFBConfigs returned
│ Stacktrace:
│  [1] _ErrorCallbackWrapper(::Int32, ::Cstring) at /home/user/.julia/packages/GLFW/CBo9c/src/callback.jl:43
│  [2] CreateWindow(::Int64, ::Int64, ::String, ::GLFW.Monitor, ::GLFW.Window) at /home/user/.julia/packages/GLFW/CBo9c/src/glfw3.jl:499
│  [3] GLFW.Window(; name::String, resolution::Tuple{Int64,Int64}, debugging::Bool, major::Int64, minor::Int64, windowhints::Array{Tuple{UInt32,Int64},1}, contexthints::Array{Tuple{UInt32,Integer},1}, visible::Bool, focus::Bool, fullscreen::Bool, monitor::Nothing, share::GLFW.Window) at /home/user/.julia/packages/GLFW/CBo9c/src/glfw3.jl:344
│  [4] top-level scope at /home/user/.julia/packages/GLMakie/9pp6B/deps/build.jl:34
│  [5] include(::String) at ./client.jl:457
│  [6] top-level scope at none:5
└ @ Pkg.Operations /build/source/usr/share/julia/stdlib/v1.5/Pkg/src/Operations.jl:949
cstich and others added 2 commits Nov 8, 2020
Co-authored-by: Sandro <sandro.jaeckel@gmail.com>
Co-authored-by: Sandro <sandro.jaeckel@gmail.com>
@cstich
Copy link
Contributor Author

@cstich cstich commented Nov 8, 2020

@energizah

@doronbehar

@energizah did you try using GLMakie.jl with the julia build of this PR?

Yeah but it didn't work.

I just tried and GLMakie.jl compiles for me but I am also using this expression to create an environment for julia.

{pkgs, stdenv, ...}:

with pkgs;
let
  julia = julia_15;
  d = version: "v${lib.concatStringsSep "." (lib.take 2 (lib.splitString "." version))}";
  extraLibs = [
    # IJulia.jl
    mbedtls
    zeromq4
    # ImageMagick.jl
    imagemagickBig
    # HDF5.jl
    hdf5
    # Cairo.jl
    cairo
    gettext
    pango.out
    glib.out
    # Gtk.jl
    gtk3
    gtk2
    #gdk_pixbuf
    gdk-pixbuf
    graphite2
    wayland

    # GZip.jl # Required by DataFrames.jl
    gzip
    zlib

    # PyPlot.jl
    qt4
    gcc
    glibc
    stdenv.cc.cc.lib

    # GR.jl # Runs even without Xrender and Xext, but cannot save files, so those are required
    xorg.libXt
    xorg.libX11
    xorg.libXrender
    xorg.libXext
    xorg.libXcomposite
    glfw
    freetype


    # Flux.jl
    cudatoolkit
    linuxPackages.nvidia_x11
    git gitRepo gnupg autoconf curl
    procps gnumake utillinux m4 gperf unzip
    libGLU

    xorg.libXi xorg.libXmu freeglut
    xorg.libXext xorg.libX11 xorg.libXv xorg.libXrandr zlib
    
    ncurses5 stdenv.cc binutils
    # Arpack.jl
    arpack
    gfortran.cc
    (pkgs.runCommand "openblas64_" {} ''
      mkdir -p "$out"/lib/
      ln -s ${openblasCompat}/lib/libopenblas.so "$out"/lib/libopenblas64_.so.0
    '')
  ];
in
stdenv.mkDerivation rec {
  name = "julia-env";
  version = julia.version;
  nativeBuildInputs = [ makeWrapper cacert git pkgconfig which ];
  buildInputs = [
    julia
    /* jupyterEnv  # my custom jupyter */
  ] ++ extraLibs;
  phases = [ "installPhase" ];
  installPhase = ''
    export CUDA_PATH="${cudatoolkit}"
    export LD_LIBRARY_PATH=${lib.makeLibraryPath extraLibs}
    export LD_LIBRARY_PATH=${gdk-pixbuf.dev}/bin/:LD_LIBRARY_PATH
    
    echo $LD_LIBRARY_PATH
    # pushd $JULIA_PKGDIR/${d version}
    makeWrapper ${julia}/bin/julia $out/bin/julia \
        --prefix LD_LIBRARY_PATH : "$LD_LIBRARY_PATH" \
        --prefix LD_LIBRARY_PATH ":" "${linuxPackages.nvidia_x11}/lib" \
        --set CUDA_PATH "${cudatoolkit}" \
        --set JULIA_PKGDIR $JULIA_PKGDIR
        # --set JULIA_LOAD_PATH $JULIA_PKGDIR/${d version}
  '';
}
@energizah
Copy link

@energizah energizah commented Nov 8, 2020

@cstich I don't think that's working for me. I'm on an Intel graphics card.

% result/bin/julia --project=. -e 'import Pkg; Pkg.build("GLMakie")'
   Building ModernGL → `~/.julia/packages/ModernGL/rVuW2/deps/build.log`
   Building FFTW ────→ `~/.julia/packages/FFTW/DMUbN/deps/build.log`
   Building GLMakie ─→ `~/.julia/packages/GLMakie/9pp6B/deps/build.log`
┌ Error: Error building `GLMakie`: 
│ init error of GLFW
│ ERROR: LoadError: OpenGL/GLFW wasn't installed correctly. This likely means,
│ you don't have an OpenGL capable Graphic Card,
│ you don't have the newest video driver installed,
│ or the GLFW build failed. If you're on linux and `]build` GLFW failed,
│ try manually adding `sudo apt-get install libglfw3` and then `]build GLMakie`.
│ If you're on a headless server, you still need to install x-server and
│ proper GPU drivers. You can take inspiration from this article
│ on how to get Makie running on a headless system:
│ https://nextjournal.com/sdanisch/makie-1.0
│ If you don't have a GPU, there is also a Cairo software backend
│ for Makie which you can use:
│ https://github.com/JuliaPlots/CairoMakie.jl.
│ Please check the below error and open an issue at:
│ https://github.com/JuliaPlots/GLMakie.jl.
│ After you fixed your OpenGL install, please run `]build GLMakie` again!
│ GLMakie will still load, but will be disabled as a default backend for Makie
│ 
│ Stacktrace:
│  [1] error(::String) at /nix/store/lkviqn14m8cd35m1y9y7bc3iy148f515-julia-1.5.2/lib/julia/sys.so:?
│  [2] top-level scope at /home/user/.julia/packages/GLMakie/9pp6B/deps/build.jl:63
│  [3] include(::String) at ./client.jl:457
│  [4] top-level scope at none:5
│ in expression starting at /home/user/.julia/packages/GLMakie/9pp6B/deps/build.jl:31
│ caused by [exception 1]
│ GLFWError (API_UNAVAILABLE): GLX: No GLXFBConfigs returned
│ Stacktrace:
│  [1] _ErrorCallbackWrapper(::Int32, ::Cstring) at /home/user/.julia/packages/GLFW/CBo9c/src/callback.jl:43
│  [2] CreateWindow(::Int64, ::Int64, ::String, ::GLFW.Monitor, ::GLFW.Window) at /home/user/.julia/packages/GLFW/CBo9c/src/glfw3.jl:499
│  [3] GLFW.Window(; name::String, resolution::Tuple{Int64,Int64}, debugging::Bool, major::Int64, minor::Int64, windowhints::Array{Tuple{UInt32,Int64},1}, contexthints::Array{Tuple{UInt32,Integer},1}, visible::Bool, focus::Bool, fullscreen::Bool, monitor::Nothing, share::GLFW.Window) at /home/user/.julia/packages/GLFW/CBo9c/src/glfw3.jl:344
│  [4] top-level scope at /home/user/.julia/packages/GLMakie/9pp6B/deps/build.jl:34
│  [5] include(::String) at ./client.jl:457
│  [6] top-level scope at none:5
└ @ Pkg.Operations /build/source/usr/share/julia/stdlib/v1.5/Pkg/src/Operations.jl:949
@doronbehar
Copy link
Contributor

@doronbehar doronbehar commented Nov 8, 2020

Maybe addOpenGLRunpath could help? Example usage:

nativeBuildInputs = [
addOpenGLRunpath docutils perl pkgconfig python3 wafHook which
]

# Set RUNPATH so that libcuda in /run/opengl-driver(-32)/lib can be found.
# See the explanation in addOpenGLRunpath.
postFixup = optionalString stdenv.isLinux ''
addOpenGLRunpath $out/bin/mpv
'';

According to this:

# Set RUNPATH so that driver libraries in /run/opengl-driver(-32)/lib can be found.
# This is needed to not rely on LD_LIBRARY_PATH which does not work with setuid
# executables. Fixes https://github.com/NixOS/nixpkgs/issues/22760. It must be run
# in postFixup because RUNPATH stripping in fixup would undo it. Note that patchelf
# actually sets RUNPATH not RPATH, which applies only to dependencies of the binary
# it set on (including for dlopen), so the RUNPATH must indeed be set on these
# libraries and would not work if set only on executables.

It should be possible to test with an existing Julia build if it helps using LD_LIBRARY_PATH with /run/opengl-driver/lib.

@energizah
Copy link

@energizah energizah commented Nov 8, 2020

@doronbehar Yeah that LD_LIBRARY_PATH works for me.

@doronbehar
Copy link
Contributor

@doronbehar doronbehar commented Nov 8, 2020

@doronbehar Yeah that LD_LIBRARY_PATH works for me.

OK! So I think we'll finally be able to solve our julia issue 🎉. @cstich if you could please use dontUseCmakeConfigure, and perhaps pull in that openGLRunPathHook?

@energizah
Copy link

@energizah energizah commented Nov 9, 2020

That success was on NixOS. On a CentOS machine where I don't have root, I can't build the julia_15 derivation.

3f7c8508930d32f45325c00ab87871fe4b9b570d:$ result/bin/nix-build -A julia_15
these derivations will be built:
  /nix/store/s0p31n7nidids7d514k1m22wlxdvs0dj-julia-1.5.2.drv
building '/nix/store/s0p31n7nidids7d514k1m22wlxdvs0dj-julia-1.5.2.drv'...
unpacking sources
unpacking source archive /nix/store/5rwcvdninf6vxan4lbvjhmdnc9g09mlv-source
cp: setting permissions for 'source': Invalid argument
do not know how to unpack source archive /nix/store/5rwcvdninf6vxan4lbvjhmdnc9g09mlv-source
builder for '/nix/store/s0p31n7nidids7d514k1m22wlxdvs0dj-julia-1.5.2.drv' failed with exit code 1
error: build of '/nix/store/s0p31n7nidids7d514k1m22wlxdvs0dj-julia-1.5.2.drv' failed
@doronbehar
Copy link
Contributor

@doronbehar doronbehar commented Nov 9, 2020

That success was on NixOS. On a CentOS machine where I don't have root, I can't build the julia_15 derivation.

Unsandboxed systems are not officially supported for as far as I know. Hence I think it shouldn't block this PR. I've many times encountered such weird issues in user's reports which seem like fundamental issues in building any package.

@7c6f434c
Copy link
Member

@7c6f434c 7c6f434c commented Nov 9, 2020

@doronbehar
Copy link
Contributor

@doronbehar doronbehar commented Nov 11, 2020

1.5.3 was released.

@ofborg ofborg bot requested a review from 7c6f434c Nov 13, 2020
7c6f434c added 2 commits Nov 13, 2020
@7c6f434c
Copy link
Member

@7c6f434c 7c6f434c commented Nov 13, 2020

@ofborg eval

@7c6f434c 7c6f434c merged commit 5a5cb55 into NixOS:master Nov 13, 2020
18 of 20 checks passed
18 of 20 checks passed
tests
Details
action
Details
Wait for ofborg This failed status will be cleared when ofborg finishes eval.
Details
julia_15 on x86_64-darwin
Details
Evaluation Performance Report Evaluator Performance Report
Details
grahamcofborg-eval ^.^!
Details
grahamcofborg-eval-check-maintainers matching changed paths to changed attrs...
Details
grahamcofborg-eval-check-meta config.nix: checkMeta = true
Details
grahamcofborg-eval-darwin nix-instantiate --arg nixpkgs { outPath=./.; revCount=999999; shortRev="c16ba37"; rev="c16ba375f9ca43e1123489f2a62f1faa2082025f"; } ./pkgs/t
Details
grahamcofborg-eval-lib-tests nix-build --arg pkgs import ./. {} ./lib/tests/release.nix
Details
grahamcofborg-eval-nixos nix-instantiate --arg nixpkgs { outPath=./.; revCount=999999; shortRev="c16ba37"; rev="c16ba375f9ca43e1123489f2a62f1faa2082025f"; } ./nixos/
Details
grahamcofborg-eval-nixos-manual nix-instantiate --arg nixpkgs { outPath=./.; revCount=999999; shortRev="c16ba37"; rev="c16ba375f9ca43e1123489f2a62f1faa2082025f"; } ./nixos/
Details
grahamcofborg-eval-nixos-options nix-instantiate --arg nixpkgs { outPath=./.; revCount=999999; shortRev="c16ba37"; rev="c16ba375f9ca43e1123489f2a62f1faa2082025f"; } ./nixos/
Details
grahamcofborg-eval-nixpkgs-manual nix-instantiate --arg nixpkgs { outPath=./.; revCount=999999; shortRev="c16ba37"; rev="c16ba375f9ca43e1123489f2a62f1faa2082025f"; } ./pkgs/t
Details
grahamcofborg-eval-nixpkgs-tarball nix-instantiate --arg nixpkgs { outPath=./.; revCount=999999; shortRev="c16ba37"; rev="c16ba375f9ca43e1123489f2a62f1faa2082025f"; } ./pkgs/t
Details
grahamcofborg-eval-nixpkgs-unstable-jobset nix-instantiate --arg nixpkgs { outPath=./.; revCount=999999; shortRev="c16ba37"; rev="c16ba375f9ca43e1123489f2a62f1faa2082025f"; } ./pkgs/t
Details
grahamcofborg-eval-package-list nix-env -qa --json --file .
Details
grahamcofborg-eval-package-list-no-aliases nix-env -qa --json --file . --arg config { allowAliases = false; }
Details
julia_15 on aarch64-linux Success
Details
julia_15 on x86_64-linux Success
Details
@doronbehar doronbehar mentioned this pull request Nov 14, 2020
0 of 10 tasks complete
AnisimoffNikita added a commit to AnisimoffNikita/nixpkgs that referenced this pull request Nov 16, 2020
Fix4 (#1)
* vgrep: 2.5.0 -> 2.5.1

https://github.com/vrothberg/vgrep/releases/tag/v2.5.1

* ocamlPackages.digestif: 0.8.0 → 0.9.0

* tor-browser-bundle-bin: 10.0.2 -> 10.0.4

* webkitgtk: 2.30.1 → 2.30.2

https://webkitgtk.org/2020/10/23/webkitgtk2.30.2-released.html

* abcl: update source archive hash

Seems like the source archive for abcl 1.8.0 was replaced on 2020-10-30
on both common-lisp.net and abcl.org. Now using the new hash and
abcl.org for src.

* flyway: 7.1.1 -> 7.2.0

* turbo-geth: 2020.11.01 -> 2020.11.02

* geany: 1.37 -> 1.37.1

* vscodium: 1.51.0 -> 1.51.1

* vscode: 1.51.0 -> 1.51.1

* kitty: use installShellCompletion to install the shell completions

* kitty: 0.19.1 -> 0.19.2

https://github.com/kovidgoyal/kitty/releases/tag/v0.19.2

* librdf_raptor2: add patch for CVE-2017-18926

Fixes two heap overflows in the raptor2 rdf parsing library.

https://www.openwall.com/lists/oss-security/2017/06/07/1

* wofi: 1.2.1 -> 1.2.3

This also fixes a GDK Protocol error.

* gnomeExtensions.dash-to-panel: 39 -> 40

* oh-my-zsh: 2020-11-11 → 2020-11-12

* linux-rt_5_4: 5.4.74-rt41 -> 5.4.74-rt42

* gp2c: 0.0.11pl4 -> 0.0.12

* yabai: 3.3.0 -> 3.3.3

* haproxy: 2.2.4 -> 2.3.0

* pastebinit: fix basic usage

* k6: 0.28.0 -> 0.29.0

* linux: 5.10-rc2 -> 5.10-rc3

* icewm: 1.9.0 -> 1.9.2

* octant: init at 0.16.0 (NixOS#99546)

* jotta-cli: 0.7.33634 -> 0.7.35160

* zfsUnstable: 2.0.0-rc5 -> 2.0.0-rc6

* vimPlugins: update

* vimPlugins: resolve github repository redirects

* jetty: 9.4.31.v20200723 -> 9.4.34.v20201102

* igv: 2.8.11 -> 2.8.12

* libreoffice-qt: wrap application

Libreoffice-qt is not wrapped, thus does not launch. Notice that
wrapQtQAppsHook is used manually since all executables are shell
scripts which are not wrapped automatically.

* zathura: 0.4.5 -> 0.4.7

* zathura-pdf-mupdf: 0.3.5 -> 0.3.6, fix linking

* intel-media-sdk: 20.3.1 -> 20.4.1

* hackage2nix: disable broken builds to fix evaluation errors on Hydra

* hackage-packages.nix: automatic Haskell package set update

This update was generated by hackage2nix v2.15.5-27-g11a103b from Hackage revision
commercialhaskell/all-cabal-hashes@cb01aa6.

* haskell-time-compat: update to latest version so that binary-instances compiles

* haskell: add addTestToolDepends

* haskellPackages.optparse-applicative_0_16_0_0: Fix for compgen error

* haskellPackages.optparse-generic_1_4_4: Correct version of dependency

* haskellPackages.update-nix-fetchgit: Several fixes

Fix versions of dependencies

Generate shell completions

Wrap executable so that required executables are in PATH

Make sure necessary executables for tests are present during build

* update-nix-fetchgit: standalone small closure

* haskell: whitespace fixes

* haskellPackages.quickcheck-instances: no longer needs doJailbreak in ghc-8.8.

* haskellPackages.binary-instances: get building again

* haskell: Add documentationTarball to lib

* haskellPackages.pandoc: 2.11.1 -> 2.11.1.1

* haskellPackages.reflex-dom-core: Remove obsolete patches

* haskellPackages.matterhorn: Fix eval

* haskellPackages.haskell-language-server: Fix build

In preparation of the upcoming 0.6.0 release I wanted to fix hls.

It introduces two new plugin packages, which are not on hackage yet.

I remove apply-refact overrides, because current apply-refact versions
are compatible with all ghcs we support, according to their changelog.

I override more of the hls dependencies globally on the whole package
set, to avoid a lot of duplicate compilations. And because @peti changed
my mind about this being a good practice.

hls now uses a released version of ghcide

* haskell-language-server: 0.6.0rc -> 0.6.0

* haskellPackages: Fix eval errors

* haskellPackages: Cleanup unneeded builds

* haskell-language-server: Fix hydra config for deps

* haskellPackages.hls-hlint-plugin: Fix build on hydra

* lib: Add composeManyExtensions

* haskell: improve documentation on ghcWithHoogle and developPackage

* haskell: add withHoogle option to developPackage

* haskell: Add cabal2nixOptions to developPackage

Also neaten documentation slightly

* haskell-language-server: Fix build

Fixing a bound problem in ghcide and bumping ghc-exactprint

* haskellPackages.stack: Fix eval error

* haskell-pantry: update overrides for the new version

* qvge: init at 0.6.1

* julia: init at 1.5 (NixOS#101933)

* jmol: 14.31.14 -> 14.31.17

* mill: removing MILL_VERSION variable (NixOS#103736)

* last: 1133 -> 1145

* kpt: 0.36.1 -> 0.37.0

* python3Packages.dipy: 1.2.0 -> 1.3.0

* PULL_REQUEST_TEMPLATE.md: use rendered docs

* python3Packages.pytorch-metric-learning: 0.9.81 -> 0.9.94

* kubernetes-helm: 3.4.0 -> 3.4.1

* ubootRockPi4: init

This adds support for the Radxa Rock Pi 4 board which is based on
RK3399. The u-boot outputs from the introduced build are suitable to
build a generic image for the Rock Pi 4 by setting the following in a
custom build of $nixpkgs/nixos/modules/installer/cd-dvd/sd-image-aarch64.nix:

```
  sdImage.postBuildCommands = ''
    dd if=${pkgs.ubootRockPi4}/idbloader.img of=$img seek=64 conv=notrunc
    dd if=${pkgs.ubootROckPi4}/u-boot.itb of=$img seek=16384 conv=notrunc
  '';
```

* libthreadar: 1.3.0 -> 1.3.1

* antiprism: init at 0.26

* all-packages.nix: a small reorganization

Now the science/geometry expressions are in a same block of the all-packages
file.

* haproxy: add passthru.tests

* cloud-nuke: 0.1.18 -> 0.1.23

* lxd: 4.7 -> 4.8

https://discuss.linuxcontainers.org/t/lxd-4-8-has-been-released/9458

* liblinear: 2.41 -> 2.42

* mavproxy: 1.8.22 -> 1.8.23

* openocd: unstable-2020-09-02 -> unstable-2020-11-11

fix build failure with hidapi 0.10.0

* python37Packages.vowpalwabbit: 8.8.1 -> 8.9.0

* ocamlPackages.mirage-unix: use Dune 2

* ocamlPackages.mirage-runtime: use Dune 2

* ocamlPackages.mirage: init at 3.9.0

* arc_unpacker: init at unstable-2019-01-28

* python37Packages.sshtunnel: 0.2.1 -> 0.2.2

* python37Packages.gtts: 2.1.1 -> 2.1.2

* python37Packages.internetarchive: 1.9.5 -> 1.9.6

* python37Packages.sphinxcontrib-katex: 0.6.1 -> 0.7.1

* vte-ng: update patches to apply on vte 0.62

* musescore: fix unpack on darwin (NixOS#103651)

* utsushi: 3.59.2 -> unstable-2020-11-10

+ master should be roughly equivalent to 3.62.0
+ moving to the community repo because they are way better at fixing
  things, while upstream epson almost never merges fixes
+ great thanks to @mwilsoncoding for debugging the problem:
   + `autoconf-archive` was missing

* python37Packages.hyperopt: 0.1.2 -> 0.2.5

* nixos/telegraf: add support for native ping

* nixos/telegraf: add environmentFile option

* nixos/telegraf: switch to setting types

This allows to split up configuration into multiple modules

* nixos/telegraf: allow multiple env files

* telegraf: 1.15.2 -> 1.16.2

* fahviewer: 7.6.13 -> 7.6.21 (NixOS#103688)

* fahcontrol: 7.6.13 -> 7.6.21 (NixOS#103677)

* phonemizer: init at 2.2.1

* sacc: 1.01 → 1.02

* verilog: unstable-2020-10-24 -> 11.0

* vhd2vl: fix compatibility with verilog 11.0

* hsetroot: 1.0.2 -> 1.0.5

* python37Packages.casbin: 0.9.0 -> 0.10.0

* Revert "Merge NixOS#102138: thunderbird: set build timeout at eight hours"

This reverts commit ef543fb, reversing
changes made to 0d657b9.
See the parent commit.

* linux-rt_5_4: 5.4.74-rt42 -> 5.4.77-rt43

* pijul: 1.0.0-alpha -> 1.0.0-alpha.1

* simh: init at 3.11-1

* pythonPackages.notmuch2: init at 0.31

generates bindings via cffi

* doc/contributing: remove label instructions

ofborg largely does this now

* nvidia-x11: 455.28 -> 455.38 (NixOS#103830)

* cloudflared: 2020.11.3 -> 2020.11.5

* dasel: 1.2.0 -> 1.5.1

* doctl: 1.51.0 -> 1.52.0

* flyctl: 0.0.146 -> 0.0.149

* font-manager: 0.7.8 -> 0.7.9

* ft2-clone: 1.39 -> 1.40

* hugo: 0.78.1 -> 0.78.2

* iconpack-obsidian: 4.13 -> 4.14

* python37Packages.pyvips: 2.1.12 -> 2.1.13

* python37Packages.dropbox: 10.8.0 -> 10.10.0

* python37Packages.versioneer: 0.18 -> 0.19

* python2Packages.versioneer: disable python2

* python37Packages.cmd2: 1.3.11 -> 1.4.0

* python37Packages.azure-mgmt-policyinsights: 0.5.0 -> 0.6.0

* python37Packages.bpython: 0.20 -> 0.20.1

* python37Packages.distributed: 2.30.0 -> 2.30.1

* kube3d: 3.2.0 -> 3.2.1

* scheherazade-new: init at 3.000

* lazydocker: 0.9 -> 0.10

* matcha-gtk-theme: 2020-10-23 -> 2020-11-11-0

* html-proofer: 3.16.0 -> 3.17.0

* coq_8_12: 8.12.0 → 8.12.1

* musikcube: 0.94.0 -> 0.95.0

* mutt: 2.0.0 -> 2.0.1

Signed-off-by: Matthias Beyer <mail@beyermatthias.de>

* firefox: 82.0.2 -> 82.0.3

* firefox-esr: 78.4.0esr -> 78.4.1esr

* pmix: 3.2.0 -> 3.2.1

* chicken: support darwin platform (NixOS#103748)

Darwin was not included as a supported platform for chicken. However, it compiled and
worked fine after bypassing unsupported platforms.

We make two changes to chicken's derivation. First, we add darwin as a supported
platform.

Second, we set some envvars that force the build to use nix-supplied build
tools. Chicken's Makefile for macOS hardcodes paths to gcc and other build tools
(see
https://code.call-cc.org/cgi-bin/gitweb.cgi?p=chicken-core.git;a=blob;f=Makefile.macosx;h=5d4d9b0aa1bb4c95e1ba7a55f9586fa86ee5034f;hb=317468e4994e6245d787400359726a9fb97d5d60#l31). We
override these envvars to use the wrapped $CC and bintools provided by nix to make
the build pure.

* rtsp-simple-server: 0.12.0 -> 0.12.1

* cockroachdb: fix license information

* firecracker: 0.22.0 -> 0.23.0

Closes NixOS#102789.

Signed-off-by: Austin Seipp <aseipp@pobox.com>

Co-authored-by: zowoq <59103226+zowoq@users.noreply.github.com>
Co-authored-by: Vincent Laporte <Vincent.Laporte@gmail.com>
Co-authored-by: Dominik Xaver Hörl <hoe.dom@gmx.de>
Co-authored-by: Jan Tojnar <jtojnar@gmail.com>
Co-authored-by: sternenseemann <0rpkxez4ksa01gb3typccl0i@systemli.org>
Co-authored-by: R. RyanTM <ryantm-bot@ryantm.com>
Co-authored-by: David Terry <me@xwvvvvwx.com>
Co-authored-by: JesusMtnez <jesusmartinez93@gmail.com>
Co-authored-by: Martin Weinelt <mweinelt@users.noreply.github.com>
Co-authored-by: Luflosi <luflosi@luflosi.de>
Co-authored-by: Ryan Mulligan <ryan@ryantm.com>
Co-authored-by: Martin Weinelt <hexa@darmstadt.ccc.de>
Co-authored-by: Aamaruvi Yogamani <38222826+Technical27@users.noreply.github.com>
Co-authored-by: Sean Buckley <sean.bck@gmail.com>
Co-authored-by: Andreas Rammhold <andreas@rammhold.de>
Co-authored-by: Tim Steinbach <tim@nequissimus.com>
Co-authored-by: cmacrae <hi@cmacr.ae>
Co-authored-by: Arnout Engelen <arnout@bzzt.net>
Co-authored-by: Jack Kelly <dev@j-k.io>
Co-authored-by: Vladyslav M <dywedir@gra.red>
Co-authored-by: Jonathan Ringer <jonringer117@gmail.com>
Co-authored-by: Will Badart <will@willbadart.com>
Co-authored-by: Jonas Meurer <jmpunkt@outlook.com>
Co-authored-by: Frederik Rietdijk <fridh@fridh.nl>
Co-authored-by: Peter Simons <simons@cryp.to>
Co-authored-by: Joe Hermaszewski <git@monoid.al>
Co-authored-by: (cdep)illabout <cdep.illabout@gmail.com>
Co-authored-by: Malte Brandy <malte.brandy@maralorn.de>
Co-authored-by: Nikolay Korotkiy <sikmir@gmail.com>
Co-authored-by: Christoph Stich <cstich@users.noreply.github.com>
Co-authored-by: Anderson Torres <torres.anderson.85@protonmail.com>
Co-authored-by: scalavision <scalavision@gmail.com>
Co-authored-by: Ben Darwin <bcdarwin@gmail.com>
Co-authored-by: Mario Rodas <marsam@users.noreply.github.com>
Co-authored-by: Samuel Dionne-Riel <samuel@dionne-riel.com>
Co-authored-by: WORLDofPEACE <worldofpeace@protonmail.ch>
Co-authored-by: Pavol Rusnak <pavol@rusnak.io>
Co-authored-by: Doron Behar <doron.behar@gmail.com>
Co-authored-by: Timo Kaufmann <timokau@zoho.com>
Co-authored-by: midchildan <git@midchildan.org>
Co-authored-by: Daniël de Kok <me@danieldk.eu>
Co-authored-by: Jamie McClymont <jamie@kwiius.com>
Co-authored-by: Dmitry Kalinkin <dmitry.kalinkin@gmail.com>
Co-authored-by: Andrew Childs <lorne@cons.org.nz>
Co-authored-by: wucke13 <wucke13@gmail.com>
Co-authored-by: Michael Raskin <7c6f434c@mail.ru>
Co-authored-by: Jörg Thalheim <joerg@thalheim.io>
Co-authored-by: Jörg Thalheim <Mic92@users.noreply.github.com>
Co-authored-by: Ninjatrappeur <NinjaTrappeur@users.noreply.github.com>
Co-authored-by: John Ericson <git@JohnEricson.me>
Co-authored-by: Marek Mahut <marek.mahut@gmail.com>
Co-authored-by: Lassulus <github@lassul.us>
Co-authored-by: SCOTT-HAMILTON <sgn.hamilton+github@protonmail.com>
Co-authored-by: Vladimír Čunát <v@cunat.cz>
Co-authored-by: Matthieu Coudron <mcoudron@hotmail.com>
Co-authored-by: Daniel Fox Franke <dfoxfranke@gmail.com>
Co-authored-by: José Romildo Malaquias <malaquias@gmail.com>
Co-authored-by: StigP <stig@stig.io>
Co-authored-by: Michael Weiss <dev.primeos@gmail.com>
Co-authored-by: Matthias Beyer <mail@beyermatthias.de>
Co-authored-by: Aaron Andersen <aaron@fosslib.net>
Co-authored-by: Mark Hudnall <me@markhudnall.com>
Co-authored-by: markuskowa <markus.kowalewski@gmail.com>
Co-authored-by: Silvan Mosberger <contact@infinisil.com>
Co-authored-by: Antonio Nuno Monteiro <anmonteiro@gmail.com>
Co-authored-by: ajs124 <ajs124@users.noreply.github.com>
Co-authored-by: Austin Seipp <aseipp@pobox.com>
github-actions bot added a commit to andir/nixos.cloud that referenced this pull request Nov 20, 2020
## Changelog for nixpkgs:
Commits: [NixOS/nixpkgs@2deeb58...069f183f](NixOS/nixpkgs@2deeb58...069f183)

* [`e86b0509`](NixOS/nixpkgs@e86b050) go-ethereum: 1.9.23 -> 1.9.24
* [`4bdd40df`](NixOS/nixpkgs@4bdd40d) awsweeper: 0.7.0 -> 0.10.2
* [`dce3b451`](NixOS/nixpkgs@dce3b45) wal-g: 0.2.17 -> 0.2.18
* [`6b4ef62e`](NixOS/nixpkgs@6b4ef62) eksctl: 0.30.0 -> 0.31.0
* [`e4ac103c`](NixOS/nixpkgs@e4ac103) dar: 2.6.12 -> 2.6.13
* [`d2a55a7f`](NixOS/nixpkgs@d2a55a7) gnomeExtensions.gsconnect: 43 -> 44
* [`897ce96b`](NixOS/nixpkgs@897ce96) kustomize: 3.8.1 -> 3.8.7
* [`be0555b8`](NixOS/nixpkgs@be0555b) nixos/doc: Add note about /usr/sbin and /sbin
* [`e5d4ce72`](NixOS/nixpkgs@e5d4ce7) discord-canary: 0.0.114 -> 0.0.115
* [`2d915726`](NixOS/nixpkgs@2d91572) dump1090: 3.8.1 -> 4.0
* [`10fc2a3a`](NixOS/nixpkgs@10fc2a3) ocamlPackages.mstruct: remove at 1.4.0
* [`568d95e1`](NixOS/nixpkgs@568d95e) forkstat: 0.02.15 -> 0.02.16
* [`26f1edbb`](NixOS/nixpkgs@26f1edb) fortune: 3.2.0 -> 3.4.1
* [`cf30b008`](NixOS/nixpkgs@cf30b00) vgrep: 2.5.0 -> 2.5.1
* [`1ce26aac`](NixOS/nixpkgs@1ce26aa) ocamlPackages.digestif: 0.8.0 → 0.9.0
* [`9e8f4ff7`](NixOS/nixpkgs@9e8f4ff) tor-browser-bundle-bin: 10.0.2 -> 10.0.4
* [`e9267c88`](NixOS/nixpkgs@e9267c8) abcl: update source archive hash
* [`c68e9c54`](NixOS/nixpkgs@c68e9c5) flyway: 7.1.1 -> 7.2.0
* [`08ca1ee8`](NixOS/nixpkgs@08ca1ee) turbo-geth: 2020.11.01 -> 2020.11.02
* [`325d9778`](NixOS/nixpkgs@325d977) geany: 1.37 -> 1.37.1
* [`bca0c78d`](NixOS/nixpkgs@bca0c78) vscodium: 1.51.0 -> 1.51.1
* [`aa9a29c4`](NixOS/nixpkgs@aa9a29c) vscode: 1.51.0 -> 1.51.1
* [`09eabf6a`](NixOS/nixpkgs@09eabf6) kitty: use installShellCompletion to install the shell completions
* [`182b7cfb`](NixOS/nixpkgs@182b7cf) kitty: 0.19.1 -> 0.19.2
* [`22140b27`](NixOS/nixpkgs@22140b2) librdf_raptor2: add patch for CVE-2017-18926
* [`8775e397`](NixOS/nixpkgs@8775e39) wofi: 1.2.1 -> 1.2.3
* [`67394b5e`](NixOS/nixpkgs@67394b5) gnomeExtensions.dash-to-panel: 39 -> 40
* [`7a36556e`](NixOS/nixpkgs@7a36556) oh-my-zsh: 2020-11-11 → 2020-11-12
* [`eb64d151`](NixOS/nixpkgs@eb64d15) linux-rt_5_4: 5.4.74-rt41 -> 5.4.74-rt42
* [`3457f858`](NixOS/nixpkgs@3457f85) gp2c: 0.0.11pl4 -> 0.0.12
* [`7fb1069a`](NixOS/nixpkgs@7fb1069) yabai: 3.3.0 -> 3.3.3
* [`4fb71e29`](NixOS/nixpkgs@4fb71e2) haproxy: 2.2.4 -> 2.3.0
* [`9ebf4409`](NixOS/nixpkgs@9ebf440) pastebinit: fix basic usage
* [`65ac9e26`](NixOS/nixpkgs@65ac9e2) k6: 0.28.0 -> 0.29.0
* [`c9845cda`](NixOS/nixpkgs@c9845cd) linux: 5.10-rc2 -> 5.10-rc3
* [`04d5b2f8`](NixOS/nixpkgs@04d5b2f) icewm: 1.9.0 -> 1.9.2
* [`d01e5dc6`](NixOS/nixpkgs@d01e5dc) octant: init at 0.16.0 (NixOS/nixpkgs#99546)
* [`0428243f`](NixOS/nixpkgs@0428243) jotta-cli: 0.7.33634 -> 0.7.35160
* [`f525d54c`](NixOS/nixpkgs@f525d54) zfsUnstable: 2.0.0-rc5 -> 2.0.0-rc6
* [`5eeff0d2`](NixOS/nixpkgs@5eeff0d) vimPlugins: update
* [`f53113e5`](NixOS/nixpkgs@f53113e) vimPlugins: resolve github repository redirects
* [`d4da5f9d`](NixOS/nixpkgs@d4da5f9) jetty: 9.4.31.v20200723 -> 9.4.34.v20201102
* [`82d11130`](NixOS/nixpkgs@82d1113) igv: 2.8.11 -> 2.8.12
* [`ea12d880`](NixOS/nixpkgs@ea12d88) libreoffice-qt: wrap application
* [`c62f9475`](NixOS/nixpkgs@c62f947) zathura: 0.4.5 -> 0.4.7
* [`6e9b71f0`](NixOS/nixpkgs@6e9b71f) zathura-pdf-mupdf: 0.3.5 -> 0.3.6, fix linking
* [`73ca6f3e`](NixOS/nixpkgs@73ca6f3) intel-media-sdk: 20.3.1 -> 20.4.1
* [`3bf200de`](NixOS/nixpkgs@3bf200d) hackage2nix: disable broken builds to fix evaluation errors on Hydra
* [`1f021c26`](NixOS/nixpkgs@1f021c2) hackage-packages.nix: automatic Haskell package set update
* [`9028b8f3`](NixOS/nixpkgs@9028b8f) haskell-time-compat: update to latest version so that binary-instances compiles
* [`a3d8c128`](NixOS/nixpkgs@a3d8c12) haskell: add addTestToolDepends
* [`4f0af81b`](NixOS/nixpkgs@4f0af81) haskellPackages.optparse-applicative_0_16_0_0: Fix for compgen error
* [`738d4fef`](NixOS/nixpkgs@738d4fe) haskellPackages.optparse-generic_1_4_4: Correct version of dependency
* [`b95bea03`](NixOS/nixpkgs@b95bea0) haskellPackages.update-nix-fetchgit: Several fixes
* [`e5570d9f`](NixOS/nixpkgs@e5570d9) update-nix-fetchgit: standalone small closure
* [`407bb3ba`](NixOS/nixpkgs@407bb3b) haskell: whitespace fixes
* [`01a403fb`](NixOS/nixpkgs@01a403f) haskellPackages.quickcheck-instances: no longer needs doJailbreak in ghc-8.8.
* [`bbb5016d`](NixOS/nixpkgs@bbb5016) haskellPackages.binary-instances: get building again
* [`7673eda1`](NixOS/nixpkgs@7673eda) haskell: Add documentationTarball to lib
* [`bc1ffa45`](NixOS/nixpkgs@bc1ffa4) haskellPackages.pandoc: 2.11.1 -> 2.11.1.1
* [`798e23c7`](NixOS/nixpkgs@798e23c) haskellPackages.reflex-dom-core: Remove obsolete patches
* [`becd5f5b`](NixOS/nixpkgs@becd5f5) haskellPackages.matterhorn: Fix eval
* [`bf29c147`](NixOS/nixpkgs@bf29c14) haskellPackages.haskell-language-server: Fix build
* [`13f96d5d`](NixOS/nixpkgs@13f96d5) haskell-language-server: 0.6.0rc -> 0.6.0
* [`425d22e6`](NixOS/nixpkgs@425d22e) haskellPackages: Fix eval errors
* [`ed26917b`](NixOS/nixpkgs@ed26917) haskellPackages: Cleanup unneeded builds
* [`3cbe2b5b`](NixOS/nixpkgs@3cbe2b5) haskell-language-server: Fix hydra config for deps
* [`bacdeffd`](NixOS/nixpkgs@bacdeff) haskellPackages.hls-hlint-plugin: Fix build on hydra
* [`c3b35f21`](NixOS/nixpkgs@c3b35f2) lib: Add composeManyExtensions
* [`07e697d2`](NixOS/nixpkgs@07e697d) haskell: improve documentation on ghcWithHoogle and developPackage
* [`a32c2310`](NixOS/nixpkgs@a32c231) haskell: add withHoogle option to developPackage
* [`49e9758e`](NixOS/nixpkgs@49e9758) haskell: Add cabal2nixOptions to developPackage
* [`0f1709ad`](NixOS/nixpkgs@0f1709a) haskell-language-server: Fix build
* [`bf2b91cf`](NixOS/nixpkgs@bf2b91c) haskellPackages.stack: Fix eval error
* [`9ea5a41d`](NixOS/nixpkgs@9ea5a41) haskell-pantry: update overrides for the new version
* [`986d973f`](NixOS/nixpkgs@986d973) qvge: init at 0.6.1
* [`5a5cb550`](NixOS/nixpkgs@5a5cb55) julia: init at 1.5 (NixOS/nixpkgs#101933)
* [`dd8591d7`](NixOS/nixpkgs@dd8591d) jmol: 14.31.14 -> 14.31.17
* [`c1dfbaa8`](NixOS/nixpkgs@c1dfbaa) mill: removing MILL_VERSION variable (NixOS/nixpkgs#103736)
* [`a698dfa0`](NixOS/nixpkgs@a698dfa) last: 1133 -> 1145
* [`d4a4860e`](NixOS/nixpkgs@d4a4860) kpt: 0.36.1 -> 0.37.0
* [`001a975b`](NixOS/nixpkgs@001a975) python3Packages.dipy: 1.2.0 -> 1.3.0
* [`698c4713`](NixOS/nixpkgs@698c471) PULL_REQUEST_TEMPLATE.md: use rendered docs
* [`c881ca60`](NixOS/nixpkgs@c881ca6) python3Packages.pytorch-metric-learning: 0.9.81 -> 0.9.94
* [`d1a603b5`](NixOS/nixpkgs@d1a603b) kubernetes-helm: 3.4.0 -> 3.4.1
* [`7a5047be`](NixOS/nixpkgs@7a5047b) ubootRockPi4: init
* [`2f4bd223`](NixOS/nixpkgs@2f4bd22) libthreadar: 1.3.0 -> 1.3.1
* [`7225ae36`](NixOS/nixpkgs@7225ae3) haproxy: add passthru.tests
* [`ac676f13`](NixOS/nixpkgs@ac676f1) cloud-nuke: 0.1.18 -> 0.1.23
* [`a398eb85`](NixOS/nixpkgs@a398eb8) lxd: 4.7 -> 4.8
* [`06d328c3`](NixOS/nixpkgs@06d328c) liblinear: 2.41 -> 2.42
* [`df7db2b3`](NixOS/nixpkgs@df7db2b) mavproxy: 1.8.22 -> 1.8.23
* [`5e76b77f`](NixOS/nixpkgs@5e76b77) openocd: unstable-2020-09-02 -> unstable-2020-11-11
* [`1f9b3967`](NixOS/nixpkgs@1f9b396) python37Packages.vowpalwabbit: 8.8.1 -> 8.9.0
* [`0e6f0204`](NixOS/nixpkgs@0e6f020) ocamlPackages.mirage-unix: use Dune 2
* [`7fb0a750`](NixOS/nixpkgs@7fb0a75) ocamlPackages.mirage-runtime: use Dune 2
* [`9ca92f0a`](NixOS/nixpkgs@9ca92f0) ocamlPackages.mirage: init at 3.9.0
* [`302cbf17`](NixOS/nixpkgs@302cbf1) arc_unpacker: init at unstable-2019-01-28
* [`91a41b05`](NixOS/nixpkgs@91a41b0) python37Packages.sshtunnel: 0.2.1 -> 0.2.2
* [`3098d504`](NixOS/nixpkgs@3098d50) python37Packages.gtts: 2.1.1 -> 2.1.2
* [`c07706ef`](NixOS/nixpkgs@c07706e) python37Packages.internetarchive: 1.9.5 -> 1.9.6
* [`e4b6e569`](NixOS/nixpkgs@e4b6e56) python37Packages.sphinxcontrib-katex: 0.6.1 -> 0.7.1
* [`2ac6d50e`](NixOS/nixpkgs@2ac6d50) vte-ng: update patches to apply on vte 0.62
* [`99d3a69d`](NixOS/nixpkgs@99d3a69) musescore: fix unpack on darwin (NixOS/nixpkgs#103651)
* [`f89b4dc4`](NixOS/nixpkgs@f89b4dc) utsushi: 3.59.2 -> unstable-2020-11-10
* [`5d08fb8f`](NixOS/nixpkgs@5d08fb8) python37Packages.hyperopt: 0.1.2 -> 0.2.5
* [`9750813b`](NixOS/nixpkgs@9750813) nixos/telegraf: add support for native ping
* [`157d7354`](NixOS/nixpkgs@157d735) nixos/telegraf: add environmentFile option
* [`8edc4619`](NixOS/nixpkgs@8edc461) nixos/telegraf: switch to setting types
* [`7534d926`](NixOS/nixpkgs@7534d92) nixos/telegraf: allow multiple env files
* [`b696d796`](NixOS/nixpkgs@b696d79) telegraf: 1.15.2 -> 1.16.2
* [`68f44d99`](NixOS/nixpkgs@68f44d9) fahviewer: 7.6.13 -> 7.6.21 (NixOS/nixpkgs#103688)
* [`e3cf6e12`](NixOS/nixpkgs@e3cf6e1) fahcontrol: 7.6.13 -> 7.6.21 (NixOS/nixpkgs#103677)
* [`8578fb31`](NixOS/nixpkgs@8578fb3) phonemizer: init at 2.2.1
* [`00251c06`](NixOS/nixpkgs@00251c0) sacc: 1.01 → 1.02
* [`65bd03c8`](NixOS/nixpkgs@65bd03c) hsetroot: 1.0.2 -> 1.0.5
* [`fb397ae7`](NixOS/nixpkgs@fb397ae) python37Packages.casbin: 0.9.0 -> 0.10.0
* [`6769ad9f`](NixOS/nixpkgs@6769ad9) Revert "Merge NixOS/nixpkgs#102138: thunderbird: set build timeout at eight hours"
* [`0c0b533f`](NixOS/nixpkgs@0c0b533) linux-rt_5_4: 5.4.74-rt42 -> 5.4.77-rt43
* [`a429039a`](NixOS/nixpkgs@a429039) pijul: 1.0.0-alpha -> 1.0.0-alpha.1
* [`c7463be4`](NixOS/nixpkgs@c7463be) simh: init at 3.11-1
* [`6bf02266`](NixOS/nixpkgs@6bf0226) pythonPackages.notmuch2: init at 0.31
* [`0e89c426`](NixOS/nixpkgs@0e89c42) doc/contributing: remove label instructions
* [`2fa89880`](NixOS/nixpkgs@2fa8988) nvidia-x11: 455.28 -> 455.38 (NixOS/nixpkgs#103830)
* [`e542a2d2`](NixOS/nixpkgs@e542a2d) flyctl: 0.0.146 -> 0.0.149
* [`16874792`](NixOS/nixpkgs@1687479) ft2-clone: 1.39 -> 1.40
* [`72c798dd`](NixOS/nixpkgs@72c798d) hugo: 0.78.1 -> 0.78.2
* [`efe6b12a`](NixOS/nixpkgs@efe6b12) python37Packages.pyvips: 2.1.12 -> 2.1.13
* [`e038ae53`](NixOS/nixpkgs@e038ae5) python37Packages.dropbox: 10.8.0 -> 10.10.0
* [`05d4955a`](NixOS/nixpkgs@05d4955) python37Packages.versioneer: 0.18 -> 0.19
* [`a0ea37d2`](NixOS/nixpkgs@a0ea37d) python2Packages.versioneer: disable python2
* [`d2928191`](NixOS/nixpkgs@d292819) python37Packages.cmd2: 1.3.11 -> 1.4.0
* [`7d129704`](NixOS/nixpkgs@7d12970) python37Packages.azure-mgmt-policyinsights: 0.5.0 -> 0.6.0
* [`0e77efac`](NixOS/nixpkgs@0e77efa) python37Packages.bpython: 0.20 -> 0.20.1
* [`fa962c1d`](NixOS/nixpkgs@fa962c1) python37Packages.distributed: 2.30.0 -> 2.30.1
* [`b94a2943`](NixOS/nixpkgs@b94a294) scheherazade-new: init at 3.000
* [`1ff209c9`](NixOS/nixpkgs@1ff209c) lazydocker: 0.9 -> 0.10
* [`dbf134a7`](NixOS/nixpkgs@dbf134a) html-proofer: 3.16.0 -> 3.17.0
* [`2806eb27`](NixOS/nixpkgs@2806eb2) coq_8_12: 8.12.0 → 8.12.1
* [`3e6fdd84`](NixOS/nixpkgs@3e6fdd8) musikcube: 0.94.0 -> 0.95.0
* [`5848e984`](NixOS/nixpkgs@5848e98) mutt: 2.0.0 -> 2.0.1
@tbenst
Copy link
Contributor

@tbenst tbenst commented Nov 24, 2020

@energizah @cstich thanks for all the work on this! I'm still struggling to get GLMakie to build. I get the same GLFWError (API_UNAVAILABLE): GLX: No GLXFBConfigs returned. I have a Nvidia GPU, and am on NixOS 20.09. Appreciate any tips!

I've tried adding addOpenGLRunpath and have verified that /run/opengl-driver/lib appears in julia> ENV["LD_LIBRARY_PATH"]

cross ref: #80936 JuliaGL/GLFW.jl#198

thomasjm added a commit to codedownio/nixpkgs that referenced this pull request Nov 25, 2020
thomasjm added a commit to codedownio/nixpkgs that referenced this pull request Dec 23, 2020
Sign up for free to join this conversation on GitHub. Already have an account? Sign in to comment
Projects
None yet
Linked issues

Successfully merging this pull request may close these issues.

None yet

9 participants